#!/bin/bash
# Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
#
# Proprietary code. All rights reserved.

if [ ! -e shared ]; then
  echo "no shared directory detected???"
  pwd
  ls -l
  exit 1
fi

# if the connect node is running, don't do anything (assuming we are restarting some processes)
nc -z -v connect.node 10011 > /dev/null 2>&1
ret=$?

# remove access tokens from shared file (at startup)
if [ $ret -ne 0 ]; then
  echo "connect node is not running. resetting shared directory"
  rm -f shared/*
  mkdir -p logs
  chmod 777 shared logs
else
  echo "connect node is running, therefore i won't reset the shared directory"
fi

