/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

-- Track what send requests we've made but have yet to observe being sequenced.
-- If events are not observed by the max sequencing time we know that the send will never be processed.
create table sequencer_client_pending_sends
(
    -- ids for distinguishing between different sequencer clients in the same node
    client              NVARCHAR2(300) not null,
    -- the message id of the send being tracked (expected to be unique for the sequencer client while the send is in flight)
    message_id          NVARCHAR2(300) not null,
    -- the message id should be unique for the sequencer client
    constraint pk_sequencer_client_pending_sends primary key (message_id, client),
    -- the max sequencing time of the send request (UTC timestamp in microseconds relative to EPOCH)
    max_sequencing_time NUMBER          not null
);