/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

create table participant_domain_connection_configs
(
    domain_alias NVARCHAR2(300) not null constraint pk_participant_domain_connection_configs primary key,
    config       BLOB -- the protobuf-serialized versioned domain connection config
);

-- used to register all domains that a participant connects to
create table participant_domains
(
    -- to keep track of the order domains were registered
    order_number NUMBER GENERATED AS IDENTITY not null constraint pk_participant_domains primary key,
    -- domain human readable alias
    alias        NVARCHAR2(300)              not null unique,
    -- domain node id
    domain_id    NVARCHAR2(300)              not null unique,
    CONSTRAINT participant_domains_unique unique (alias, domain_id)
);
