/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

-- achieve the oracle equivalent of a partial index on timely rejections to expedite pruning
-- by making sure that all index expressions are NULL when the row should not be indexed
create index idx_event_log_associated_domain on event_log
  (case when name = 'participant-event-log' -- must be the same as the ParticipantEventLogId.name
   then associated_domain end,
   case when name = 'participant-event-log' and associated_domain is not null then ts end);
