/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

create table transfers
(
    -- transfer id
    target_domain                      NVARCHAR2(300) not null,
    origin_domain                      NVARCHAR2(300) not null,
    -- UTC timestamp in microseconds relative to EPOCH
    request_timestamp                  NUMBER          not null,
    constraint pk_transfers primary key (target_domain, origin_domain, request_timestamp),

    -- transfer data

    -- UTC timestamp in microseconds relative to EPOCH
    transfer_out_timestamp             NUMBER          not null,
    transfer_out_request_counter       NUMBER          not null,
    transfer_out_request               BLOB            not null,
    -- UTC timestamp in microseconds relative to EPOCH
    transfer_out_decision_time         NUMBER          not null,
    contract                           BLOB            not null,
    creating_transaction_id            BLOB            not null,
    transfer_out_result                BLOB,
    submitter_lf                       NVARCHAR2(300) not null,

    -- defined if transfer was completed
    time_of_completion_request_counter NUMBER,
    -- UTC timestamp in microseconds relative to EPOCH
    time_of_completion_timestamp       NUMBER
);
