/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

-- stores all requests for the request journal
create table journal_requests
(
    domain_id           NVARCHAR2(300) not null,
    request_counter     NUMBER          not null,
    request_state_index NUMBER          not null,
    -- UTC timestamp in microseconds relative to EPOCH
    request_timestamp   NUMBER          not null,
    -- UTC timestamp in microseconds relative to EPOCH
    -- is set only if the request is clean
    commit_time         NUMBER,
    repair_context      NVARCHAR2(300), -- only set on manual repair requests outside of sync protocol
    constraint pk_journal_requests primary key (request_counter, domain_id)
);
create index idx_journal_request_timestamp on journal_requests (domain_id, request_timestamp);
create index idx_journal_request_commit_time on journal_requests (domain_id, commit_time);

-- the last recorded head clean counter for each domain
create table head_clean_counters
(
    client          NVARCHAR2(300) not null constraint pk_head_clean_counters primary key,
    prehead_counter NUMBER          not null, -- request counter of the prehead request
    -- UTC timestamp in microseconds relative to EPOCH
    ts              NUMBER          not null
);
