/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

-- Maintains the latest timestamp (by domain) for which ACS commitment pruning has started or finished
create table commitment_pruning
(
    domain_id NVARCHAR2(300) not null,
    phase     VARCHAR2(100)  not null check (phase in ('started', 'completed')),
    -- UTC timestamp in microseconds relative to EPOCH
    ts        NUMBER          not null,
    constraint pk_commitment_pruning primary key (domain_id)
);

-- Maintains the latest timestamp (by sequencer client) for which the sequenced event store pruning has started or finished
create table sequenced_event_store_pruning
(
    client NVARCHAR2(300) not null,
    phase  VARCHAR2(100)  not null check (phase in ('started', 'completed')),
    -- UTC timestamp in microseconds relative to EPOCH
    ts     NUMBER          not null,
    constraint pk_sequenced_event_store_pruning primary key (client)
);

-- Maintains the latest timestamp (by domain) for which ACS pruning has started or finished
create table active_contract_pruning
(
    domain_id NVARCHAR2(300) not null,
    phase     VARCHAR2(100)  not null check (phase in ('started', 'completed')),
    -- UTC timestamp in microseconds relative to EPOCH
    ts        NUMBER          not null,
    constraint pk_active_contract_pruning primary key (domain_id)
);

-- Maintains the latest timestamp (by domain) for which contract key journal pruning has started or finished
create table contract_key_pruning
(
    domain_id NVARCHAR2(300) not null,
    phase     VARCHAR2(100)  not null check (phase in ('started', 'completed')),
    -- UTC timestamp in microseconds relative to EPOCH
    ts        NUMBER          not null,
    constraint pk_contract_key_pruning primary key (domain_id)
);
