/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

-- table to contain the values provided by the domain to the mediator node for initialization.
-- we persist these values to ensure that the mediator can always initialize itself with these values
-- even if it was to crash during initialization.
create table mediator_domain_configuration
(
    -- this lock column ensures that there can only ever be a single row: https://stackoverflow.com/questions/3967372/sql-server-how-to-constrain-a-table-to-contain-a-single-row
    "LOCK"                char(1) DEFAULT 'X' not null
        CONSTRAINT status_constraint check ("LOCK" = 'X') primary key,
    initial_key_context   NVARCHAR2(300)     not null,
    domain_id             NVARCHAR2(300)     not null,
    domain_parameters     BLOB                not null,
    sequencer_connection BLOB                not null
);