/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

-- Currently we only track the active mediator
-- Using this as the primary key ensures there can only be a single row in the table for the active mediator

-- Maintains the metadata of the active mediator known for the domain
create table mediator_leadership
(
    role              NVARCHAR2(100) default 'active' not null check (role = 'active'),
    -- The ephemeral id mediators assign themselves on startup (not their domain member identifier)
    mediator_uid      NVARCHAR2(300)                 not null,
    -- UTC timestamp in microseconds relative to EPOCH
    last_seen_ts      NUMBER                          not null,
    last_seen_counter NUMBER                          not null,
    -- optional UTC timestamp in microseconds for when the active mediator sent a retirement message
    retiring_ts       NUMBER                          null,
    constraint pk_mediator_leadership primary key (role)
);
