/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

create table service_agreement_acceptances
(
    agreement_id   NVARCHAR2(300) not null,
    participant_id NVARCHAR2(300) not null,
    -- Signature of the participant
    signature      BLOB            not null,
    -- Time of acceptance as UTC timestamp in microseconds relative to EPOCH
    ts             NUMBER          not null,

    -- We only store the first acceptance of an agreement for a participant
    constraint pk_service_agreement_acceptances primary key (agreement_id, participant_id)
);
