/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

-- store nonces that have been requested for authentication challenges
create table sequencer_authentication_nonces
(
    nonce           NVARCHAR2(300) constraint pk_sequencer_authentication_nonces primary key,
    member          NVARCHAR2(300) not null,
    generated_at_ts NUMBER         not null,
    expire_at_ts    NUMBER         not null
);

create index idx_nonces_for_member on sequencer_authentication_nonces (member, nonce);

-- store tokens that have been generated for successful authentication requests
create table sequencer_authentication_tokens
(
    token        NVARCHAR2(300) constraint pk_sequencer_authentication_tokens primary key,
    member       NVARCHAR2(300) not null,
    expire_at_ts NUMBER         not null
);

create index idx_tokens_for_member on sequencer_authentication_tokens (member);
