/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

create table crypto_hmac_secret (
    hmac_secret_id INTEGER default 1,
    data BLOB not null,

    -- We only support a single stored HMAC secret right now, enforced through an ID that must be 1.
    constraint pk_crypto_hmac_secret primary key (hmac_secret_id),
    constraint hmac_secret_only_one check (hmac_secret_id = 1)
);

create table crypto_private_keys (
    -- fingerprint of the key
    key_id NVARCHAR2(300) constraint pk_crypto_private_keys primary key,
    -- key purpose identifier
    purpose SMALLINT not null,
    -- Protobuf serialized key including metadata
    data BLOB not null,
    -- optional name of the key
    name NVARCHAR2(300)
);

create table crypto_certs (
    cert_id NVARCHAR2(300) constraint pk_crypto_certs primary key,
    -- PEM serialized certificate
    data BLOB not null
);

create table crypto_public_keys (
    -- fingerprint of the key
    key_id NVARCHAR2(300) constraint pk_crypto_public_keys primary key,
    -- key purpose identifier
    purpose SMALLINT not null,
    -- Protobuf serialized key
    data BLOB not null,
    -- optional name of the key
    name NVARCHAR2(300)
);
