/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

-- Currently we only track the active mediator
-- Using this as the primary key ensures there can only be a single row in the table for the active mediator
create type mediator_leadership_role as enum ('active');

-- Maintains the metadata of the active mediator known for the domain
create table mediator_leadership (
    role mediator_leadership_role not null default 'active' primary key check (role = 'active'),
    -- The ephemeral id mediators assign themselves on startup (not their domain member identifier)
    mediator_uid varchar(300) not null,
    -- UTC timestamp in microseconds relative to EPOCH
    last_seen_ts bigint not null,
    last_seen_counter bigint not null,
    -- optional UTC timestamp for when they wanted to retire
    retiring_ts bigint null
);
