/*
 * Copyright (c) 2021 Digital Asset (Switzerland) GmbH and/or its affiliates
 *
 * Proprietary code. All rights reserved.
 */

-- achieve the oracle equivalent of a filtered index on active_contracts to expedite pruning by
-- only indexing contract ids with a "deactivation" change exploiting the fact that oracle indexes do not include
-- keys when all keys are null.
create index idx_active_contracts_deactivations on active_contracts (case change when 'deactivation' then domain_id end);
